/* 
 * CycleView.h -- Interface file for the CycleView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use.
 *
 */

#import <appkit/appkit.h>

@interface CycleView:View {

	id		cyBou;
	id		cyNode;
	id		cyTriv1;
	id		cyTriv2;
	id		cyWidth;
	id		dragStyle;
	id		labelStyle;
	id		leftBoundary;
	id		rightBoundary;
	id		treeShow;

	id		evWindow;
	id		evButton;
	id		linkAge;
	id		menuCopy;
	id		menuPrint;
	id		moveWhich;
	id		nodeNumber;
	id		ruleNumber;

	id		oneRoot;

	id		wholePanel;
	id		cycleWindow;
	id		scrollWindow;
	id		peekView;
	id		timeDate;

	id		movement;

	id		parameters;

	id		angSlid;
	id		angText;
	id		dskSlid;
	id		dskText;
	id		radSlid;
	id		radText;

	id		delegate;
	id		browser;
	id		rootViews;
	id		rootWindows;
	id		crossCursor;

	char		*filename;
	char		**filenames;

}

- close:sender;
- cyclMove:sender;
- cySample:sender;
- drawCycle:sender;
- ediOpt:sender;
- locAte:sender;
- makeTree:sender;
- markAngle:sender;
- markDysk:sender;
- markRadius:sender;
- prepareCycle:sender;
- openCycl:sender;
- printCycle:sender;
- redrawCycle:sender;
- saveCycl:sender;
- saveCyclAs:sender;
- setCyTriv;
- setGraphData;
- showCycle:sender;

- initFrame:(const NXRect *)frameRect;
- setDelegate:anObject;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- mouseDown:(NXEvent *)theEvent;
- mouzeDown:(int)i;
@end

