
/* 
 * RECTView.h -- Interface file for the RECTView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use, nor even that it has a use.
 *
 */

#import <appkit/appkit.h>

@interface RECTView:View {

	id		keyWindow;
	id		freqView;
	id		freqWindow;
	id		planeView;
	id		planeWindow;
	id		rtrnView;
	id		rtrnWindow;
	id		RectView;
	id		RectWindow;
	id		rectView;
	id		rectWindow;
	id		trajView;
	id		trajWindow;

	id		eachAndAll;
	id		freqColor0;
	id		freqColor1;
	id		freqColor2;
	id		freqColor3;
	id		freqColor4;
	id		freqColor5;
	id		freqColor6;
	id		freqColor7;
	id		freqPerm0;
	id		freqPerm1;
	id		freqPerm2;
	id		freqPerm3;
	id		freqPerm4;
	id		freqPerm5;
	id		freqPerm6;
	id		freqPerm7;
	id		justTheView;

	id		stretchOut;

	id		theToMatrix;
	id		mMent;
	id		reStore;
	id		reStock;
	id		genEv;
	id		moTies;
	id		probDots;
	id		probGrid;

	id		cellNhood;
	id		rulePanel;
	id		ruleNumber;
	id		ruleType;
	id		pSliders;
	id		pWindows;
	id		tRuleNumber;
	id		xsRuleNumber;
	id		ysRuleNumber;

	id		menuCopy;
	id		menuPrint;

	id		tiTime;
	id		tiDat;

	id		delegate;
	id		crossCursor;

}

- checkerBoard:sender;
- chmindex:sender;
- copyRule:sender;
- copyStretch:sender;
- copyTRule:sender;
- drawBern:sender;
- drawEmpBern:sender;
- drawFreq:sender;
- drawFrequency:sender;
- drawMosaic:sender;
- drawPlEvol:sender;
- drawRtrn:sender;
- drawSmEvol:sender;
- drawSmMosaic:sender;
- drawTraj:sender;
- enterRule:sender;
- enterTRule:sender;
- fullcomp:sender;
- halfcomp:sender;
- loadRect:sender;
- printFreq:sender;
- printMosaic:sender;
- printPlEvol:sender;
- printRtrn:sender;
- printRule:sender;
- printSlowFreq:sender;
- printSmEvol:sender;
- printSmMosaic:sender;
- printTraj:sender;
- randomLine:sender;
- readRule:sender;
- readTRule:sender;
- resetRule:sender;
- sCellLine:sender;
- showProbability:sender;
- slowFreq:sender;
- uniformLine:sender;

- uprule:sender;
- lerule:sender;
- dorule:sender;
- rirule:sender;
- idrule:sender;
- cmrule:sender;
- mjrule:sender;

- initFrame:(const NXRect *)frameRect;
- setDelegate:anObject;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- mouseDown:(NXEvent *)theEvent;

@end

/* end RECTView.h */
