
/* 
 * VN3DView.h -- Interface file for the VN3DView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use, nor even that it has a use.
 *
 */

#import <appkit/appkit.h>

@interface VN3DView:View {

	id		keyWindow;
	id		bernView;
	id		freqView;
	id		freqWindow;
	id		cubeView;
	id		cubeWindow;
	id		GolayPanel;
	id		GolayView;
	id		planeView;
	id		planeWindow;
	id		rtrnView;
	id		rtrnWindow;
	id		sfreqView;
	id		sfreqWindow;
	id		ufreqView;
	id		ufreqWindow;
	id		SqarView;
	id		SqarWindow;
	id		sqarView;
	id		sqarWindow;
	id		stretchView;
	id		stretchWindow;
	id		trajView;
	id		trajWindow;

	id		eachAndAll;
	id		freqColor0;
	id		freqColor1;
	id		freqColor2;
	id		freqColor3;
	id		freqColor4;
	id		freqColor5;
	id		freqColor6;
	id		freqColor7;
	id		freqPerm0;
	id		freqPerm1;
	id		freqPerm2;
	id		freqPerm3;
	id		freqPerm4;
	id		freqPerm5;
	id		freqPerm6;
	id		freqPerm7;
	id		justTheView;

	id		eachAndSAll;
	id		sfreqColor00;
	id		sfreqColor01;
	id		sfreqColor02;
	id		sfreqColor03;
	id		sfreqColor04;
	id		sfreqColor05;
	id		sfreqColor06;
	id		sfreqColor10;
	id		sfreqColor11;
	id		sfreqColor12;
	id		sfreqColor13;
	id		sfreqColor14;
	id		sfreqColor15;
	id		sfreqColor16;
	id		sfreqPerm0;
	id		sfreqPerm1;
	id		justTheSView;

	id		stretchOut;

	id		theZMatrix;
	id		theOMatrix;
	id		theToMatrix;
	id		mMent;
	id		reStore;
	id		reStock;
	id		genEv;
	id		moTies;
	id		probDots;
	id		probGrid;

	id		cellNhood;
	id		rulePanel;
	id		ruleNumber;
	id		ruleType;
	id		pSliders;
	id		pWindows;
	id		tRuleNumber;
	id		xsRuleNumber;
	id		ysRuleNumber;

	id		menuCopy;
	id		menuPrint;

	id		tiTime;
	id		tiDat;

	id		delegate;
	id		crossCursor;

}

- checkerBoard:sender;
- chmindex:sender;
- copyCube:sender;
- copyRule:sender;
- copyStretch:sender;
- copyTRule:sender;
- drawBern:sender;
- drawCube:sender;
- drawEmpBern:sender;
- drawFreq:sender;
- drawFrequency:sender;
- drawMosaic:sender;
- drawPlEvol:sender;
- drawRtrn:sender;
- drawSemiFreq:sender;
- drawSmEvol:sender;
- drawSmMosaic:sender;
- drawTraj:sender;
- enterRule:sender;
- enterTRule:sender;
- evolveCube:sender;
- golaySurround:sender;
- loadSqar:sender;
- printCube:sender;
- printFreq:sender;
- printMosaic:sender;
- printPlEvol:sender;
- printRtrn:sender;
- printRule:sender;
- printSlowFreq:sender;
- printSmEvol:sender;
- printSmMosaic:sender;
- printTraj:sender;
- randomLine:sender;
- readRule:sender;
- readTRule:sender;
- resetRule:sender;
- sCellLine:sender;
- showProbability:sender;
- slowFreq:sender;
- uniformLine:sender;

- uprule:sender;
- lerule:sender;
- dorule:sender;
- rirule:sender;
- idrule:sender;
- mjrule:sender;

- initFrame:(const NXRect *)frameRect;
- setDelegate:anObject;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- mouseDown:(NXEvent *)theEvent;

@end

/* end VN3DView.h */
