
/* nxlcau33.h			*/
/* header file for lcau33.c	*/
/* 12 May 1989			*/


# define COLGRAF		4  /* graph resolution			*/
# define T80X25			3  /* text resolution			*/
# define WHCYMAG		1  /* color quad for normal screen	*/
# define YELREGR		2  /* alternative color palette 	*/
# define CR		        5  /* cursor reference - row editor	*/
# define CM		        7  /* cursor reference - main menu	*/
# define CL		       11  /* cursor reference - line editor	*/
# define AL      	    16384  /* array length			*/
# define SL		       40  /* short array length		*/
# define YL      	      320  /* (screen width) normally 320 	*/
# define KK	     		3  /* number of states per cell		*/
# define RR			7  /* length of neighborhood = 2r+1	*/ 
# define DN   (KK*KK*KK*KK*KK*KK)  /* number of distinct nodes		*/
# define DS (KK*KK*KK*KK*KK*KK*KK) /* number of distinct neighborhoods	*/
# define TS	    (RR*(KK-1)+1)  /* distinct sums w/totalistic rule	*/
# define SS           (KK*(TS-1))  /* distinct sums w/stotalistic rule	*/
# define PDN      4096	/* nodes in pair diagram = KK^4r	*/
# define SDN      8192	/* nodes in subset diagram = 2^(KK^2r)	*/
# define DDN	  4096	/* maximum nodes any de Bruijn diagram	*/
# define QDN	   128	/* maximum nodes 2-D de Bruijn diagram	*/
# define QWN	   128  /* node list 2-D de Bruijn node & link  */
# define BD		       25  /* max number Bernstein coeffs	*/ 

# define RSYM		12	/* number of rule symmetries = 2*k!	*/
# define WNML	       730	/* arry size for base 27 wolfram number */

# define CCY          6		/* circumference of max length cycle	*/
# define XCY	    729		/* max number of cycles = KK^CCY	*/

# define XAN	     52		/* nominal max number of ancestors/node	*/

# define K2     (KK*KK) 
# define K3     (KK*KK*KK) 
# define K4	(K2*K2)
# define K5	(K2*K3)
# define K6	(K3*K3)
# define K7     (K4*K3)
# define K8	(K4*K4)
# define AV	(KK*KK)

# define NX			2  /* number of sample rules		*/
# define NY		       14  /* number of REC demonstrations  	*/

# define CLEN		       76  /* rec source program length	 	*/
# define PLEN		   8*CLEN  /* rec object program length	 	*/
# define XLEN 128	/* buffer length for rec predefined */

# define DROWS		20	/* no of rows in demo menu       */
# define DCOLS		36	/* column for second col in d.m. */

# define RROWS		20	/* no of rows in demo menu       */
# define RCOLS		32	/* column for second col in d.m. */

# define HCH   32	/* characters+1 in help menus (text screen)    */
# define GCH   26	/* characters+1 in help menus (graphic screen) */

typedef union binrular {
		int one[DS]; 
		int seven[KK][KK][KK][KK][KK][KK][KK];
		} binrular;
typedef union ascrular {
		char one[DS]; 
		char seven[KK][KK][KK][KK][KK][KK][KK];
		} ascrular;
typedef union parneih {
		int one[K6*K6];
		int two[K6][K6];
	 	int twelve[KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK][KK];
		} parneih;

/* end  nxlcau33.h */
