
/* lcauk3.c				*/
/* evolution programs appropriate to	*/
/* (k,3) Linear Cellular Automata	*/
/* Harold V. McIntosh, 15 April 1992	*/

/*    Copyright (C) 1992		*/
/*    Harold V. McIntosh		*/

/* ------------------------------------ */

/* evolution for one generation */

onegen(j) int j; {
char kk;
int  i, k, i0, i1, i2, i3; long int ii;
int  j0, j1, j2, j3, j4, j5, j6;
switch (dn) {

case 1:
if (j>6) {
  stzer(); nhzer();
    j0=arr1[j-3];
    j1=arr1[j-2];
    j2=arr1[j-1];
    j3=arr1[0];
    j4=arr1[1];
    j5=arr1[2];
    j6=arr1[3];
    kk=binrule[j0][j1][j2][j3][j4][j5][j6];
    nhsum[j0][j1][j2][j3][j4][j5][j6]++;
    arr2[0]=kk;
    stsum[(int)kk]++;
  
    j0=arr1[4];
    kk=binrule[j1][j2][j3][j4][j5][j6][j0];
    nhsum[j1][j2][j3][j4][j5][j6][j0]++;
    arr2[1]=kk;
    stsum[(int)kk]++;
  
    j1=arr1[5];
    kk=binrule[j2][j3][j4][j5][j6][j0][j1];
    nhsum[j2][j3][j4][j5][j6][j0][j1]++;
    arr2[2]=kk;
    stsum[(int)kk]++;
  
  for (i=3; i<j-3; i++) {
	    j0=arr1[i-3];
	    j1=arr1[i-2];
	    j2=arr1[i-1];
	    j3=arr1[i];
	    j4=arr1[i+1];
	    j5=arr1[i+2];
	    j6=arr1[i+3];
	    kk=binrule[j0][j1][j2][j3][j4][j5][j6];
	    nhsum[j0][j1][j2][j3][j4][j5][j6]++;
	    arr2[i]=kk;
	    stsum[(int)kk]++;
	    }

    j0=arr1[j-6];
    j1=arr1[j-5];
    j2=arr1[j-4];
    j3=arr1[j-3];
    j4=arr1[j-2];
    j5=arr1[j-1];
    j6=arr1[0];
    kk=binrule[j0][j1][j2][j3][j4][j5][j6];
    nhsum[j0][j1][j2][j3][j4][j5][j6]++;
    arr2[j-3]=kk;
    stsum[(int)kk]++;
  
    j0=arr1[1];
    kk=binrule[j1][j2][j3][j4][j5][j6][j0];
    nhsum[j1][j2][j3][j4][j5][j6][j0]++;
    arr2[j-2]=kk;
    stsum[(int)kk]++;
  
    j1=arr1[2];
    kk=binrule[j2][j3][j4][j5][j6][j0][j1];
    nhsum[j2][j3][j4][j5][j6][j0][j1]++;
    arr2[j-1]=kk;
    stsum[(int)kk]++;
  
} else if (j==6) {
  stzer(); nhzer();
    j0=arr1[3];
    j1=arr1[4];
    j2=arr1[5];
    j3=arr1[0];
    j4=arr1[1];
    j5=arr1[2];
    kk=binrule[j0][j1][j2][j3][j4][j5][j0];
    nhsum[j0][j1][j2][j3][j4][j5][j0]++;
    arr2[0]=kk;
    stsum[(int)kk]++;
    kk=binrule[j1][j2][j3][j4][j5][j0][j1];
    nhsum[j1][j2][j3][j4][j5][j0][j1]++;
    arr2[1]=kk;
    stsum[(int)kk]++;
    kk=binrule[j2][j3][j4][j5][j0][j1][j2];
    nhsum[j2][j3][j4][j5][j0][j1][j2]++;
    arr2[2]=kk;
    stsum[(int)kk]++;
    kk=binrule[j3][j4][j5][j0][j1][j2][j3];
    nhsum[j3][j4][j5][j0][j1][j2][j3]++;
    arr2[3]=kk;
    stsum[(int)kk]++;
    kk=binrule[j4][j5][j0][j1][j2][j3][j4];
    nhsum[j4][j5][j0][j1][j2][j3][j4]++;
    arr2[4]=kk;
    stsum[(int)kk]++;
    kk=binrule[j5][j0][j1][j2][j3][j4][j5];
    nhsum[j5][j0][j1][j2][j3][j4][j5]++;
    arr2[5]=kk;
    stsum[(int)kk]++;
} else if (j==5) {
  stzer(); nhzer();
    j0=arr1[2];
    j1=arr1[3];
    j2=arr1[4];
    j3=arr1[0];
    j4=arr1[1];
    kk=binrule[j0][j1][j2][j3][j4][j0][j1];
    nhsum[j0][j1][j2][j3][j4][j0][j1]++;
    arr2[0]=kk;
    stsum[(int)kk]++;
    kk=binrule[j1][j2][j3][j4][j0][j1][j2];
    nhsum[j1][j2][j3][j4][j0][j1][j2]++;
    arr2[1]=kk;
    stsum[(int)kk]++;
    kk=binrule[j2][j3][j4][j0][j1][j2][j3];
    nhsum[j2][j3][j4][j0][j1][j2][j3]++;
    arr2[2]=kk;
    stsum[(int)kk]++;
    kk=binrule[j3][j4][j0][j1][j2][j3][j4];
    nhsum[j3][j4][j0][j1][j2][j3][j4]++;
    arr2[3]=kk;
    stsum[(int)kk]++;
    kk=binrule[j4][j0][j1][j2][j3][j4][j0];
    nhsum[j4][j0][j1][j2][j3][j4][j0]++;
    arr2[4]=kk;
    stsum[(int)kk]++;
} else if (j==4) {
  stzer(); nhzer();
    j0=arr1[1];
    j1=arr1[2];
    j2=arr1[3];
    j3=arr1[0];
    kk=binrule[j0][j1][j2][j3][j0][j1][j2];
    nhsum[j0][j1][j2][j3][j0][j1][j2]++;
    arr2[0]=kk;
    stsum[(int)kk]++;
    kk=binrule[j1][j2][j3][j0][j1][j2][j3];
    nhsum[j1][j2][j3][j0][j1][j2][j3]++;
    arr2[1]=kk;
    stsum[(int)kk]++;
    kk=binrule[j2][j3][j0][j1][j2][j3][j0];
    nhsum[j2][j3][j0][j1][j2][j3][j0]++;
    arr2[2]=kk;
    stsum[(int)kk]++;
    kk=binrule[j3][j0][j1][j2][j3][j0][j1];
    nhsum[j3][j0][j1][j2][j3][j0][j1]++;
    arr2[3]=kk;
    stsum[(int)kk]++;
} else if (j==3) {
  stzer(); nhzer();
    j0=arr1[0];
    j1=arr1[1];
    j2=arr1[2];
    kk=binrule[j0][j1][j2][j0][j1][j2][j0];
    nhsum[j0][j1][j2][j0][j1][j2][j0]++;
    arr2[0]=kk;
    stsum[(int)kk]++;
    kk=binrule[j1][j2][j0][j1][j2][j0][j1];
    nhsum[j1][j2][j0][j1][j2][j0][j1]++;
    arr2[1]=kk;
    stsum[(int)kk]++;
    kk=binrule[j2][j0][j1][j2][j0][j1][j2];
    nhsum[j2][j0][j1][j2][j0][j1][j2]++;
    arr2[2]=kk;
    stsum[(int)kk]++;
} else if (j==2) {
  stzer(); nhzer();
    j0=arr1[1];
    j1=arr1[0];
    kk=binrule[j0][j1][j0][j1][j0][j1][j0];
    nhsum[j0][j1][j0][j1][j0][j1][j0]++;
    arr2[0]=kk;
    stsum[(int)kk]++;
    kk=binrule[j1][j0][j1][j0][j1][j0][j1];
    nhsum[j1][j0][j1][j0][j1][j0][j1]++;
    arr2[1]=kk;
    stsum[(int)kk]++;
} else if (j==1) {
  stzer(); nhzer();
    j0=arr1[1];
    kk=binrule[j0][j0][j0][j0][j0][j0][j0];
    nhsum[j0][j0][j0][j0][j0][j0][j0]++;
    arr2[0]=kk;
    stsum[(int)kk]++;
}
if (co==1) for (ii=0; ii<j; ii++) arr1[(int)ii]=arr2[(int)(ii)];
if (co==0) for (ii=0; ii<j; ii++) arr1[(int)ii]=arr2[(int)((7*ii)%j)];
if (co==2) for (ii=0; ii<j; ii+=2) {arr1[(int)ii]=arr2[(int)((7*ii)%j)];
				 arr1[(int)ii+1]=arr2[(int)((7*ii+1)%j)];}
if (co==3) for (ii=0; ii<j; ii+=3) {arr1[(int)ii]=arr2[(int)((7*ii)%j)];
				 arr1[(int)ii+1]=arr2[(int)((7*ii+1)%j)];
				 arr1[(int)ii+2]=arr2[(int)((7*ii+2)%j)];}
if (co==4) for (ii=0; ii<j; ii+=4) {arr1[(int)ii]=arr2[(int)((7*ii)%j)];
				 arr1[(int)ii+1]=arr2[(int)((7*ii+1)%j)];
				 arr1[(int)ii+2]=arr2[(int)((7*ii+2)%j)];
				 arr1[(int)ii+3]=arr2[(int)((7*ii+3)%j)];}

if (co==5) {for (ii=0; ii<j; ii+=2) {arr1[(int)ii]=arr2[(int)((11*ii)%j)];
				 arr1[(int)ii+1]=arr2[(int)((11*ii+1)%j)];}
	    for (ii=0; ii<j; ii+=8) {
		k=arr1[(int)ii];
		arr1[(int)ii]=arr1[(int)((ii+2)%j)];
		arr1[(int)((ii+2)%j)]=k;
		k=arr1[(int)((ii+1)%j)];
		arr1[(int)((ii+1)%j)]=arr1[(int)((ii+4)%j)];
		arr1[(int)((ii+4)%j)]=k;
		k=arr1[(int)((ii+3)%j)];
		arr1[(int)((ii+3)%j)]=arr1[(int)((ii+5)%j)];
		arr1[(int)((ii+5)%j)]=k;
                }
	    }
if (co==6) {for (ii=0; ii<j; ii+=2) {arr1[(int)ii]=arr2[(int)((11*ii)%j)];
				 arr1[(int)ii+1]=arr2[(int)((11*ii+1)%j)];}
	    for (ii=0; ii<j; ii+=16) {
		k=arr1[(int)ii];
		arr1[(int)ii]=arr1[(int)((ii+2)%j)];
		arr1[(int)((ii+2)%j)]=k;
		k=arr1[(int)((ii+1)%j)];
		arr1[(int)((ii+1)%j)]=arr1[(int)((ii+4)%j)];
		arr1[(int)((ii+4)%j)]=k;
		k=arr1[(int)((ii+3)%j)];
		arr1[(int)((ii+3)%j)]=arr1[(int)((ii+5)%j)];
		arr1[(int)((ii+5)%j)]=k;

		k=arr1[(int)((ii+8)%j)];
		arr1[(int)((ii+8)%j)]=arr1[(int)((ii+10)%j)];
		arr1[(int)((ii+10)%j)]=k;
		k=arr1[(int)((ii+9)%j)];
		arr1[(int)((ii+9)%j)]=arr1[(int)((ii+15)%j)];
		arr1[(int)((ii+15)%j)]=k;
		k=arr1[(int)((ii+11)%j)];
		arr1[(int)((ii+11)%j)]=arr1[(int)((ii+13)%j)];
		arr1[(int)((ii+13)%j)]=k;
		k=arr1[(int)((ii+12)%j)];
		arr1[(int)((ii+12)%j)]=arr1[(int)((ii+14)%j)];
		arr1[(int)((ii+14)%j)]=k;
		}
	    } break;

/* The 2-D variant is essentially a hexagonal lattice, although */
/* it will be sheared in the cartesian presentation that will   */
/* be used. A central cell is surrounded by a ring of six, for  */
/* a 7-cell neighborhood. The array is 128x128.			*/

case 2: if (j<16384) break;
	  stzer(); nhzer();
	  for (i0=0; i0<128; i0++)
	  for (i1=0; i1<128; i1++) {
	    j0=arr1[ix2(i0-1,i1+1)];
	    j1=arr1[ix2(i0,i1+1)];
	    j2=arr1[ix2(i0-1,i1)];
	    j3=arr1[ix2(i0,i1)];
	    j4=arr1[ix2(i0+1,i1)];
	    j5=arr1[ix2(i0,i1-1)];
	    j6=arr1[ix2(i0+1,i1-1)];
	    kk=binrule[j0][j1][j2][j3][j4][j5][j6];
	    nhsum[j0][j1][j2][j3][j4][j5][j6]++;
	    arr2[ix2(i0,i1)]=kk;
	    stsum[(int)kk]++;
	    }
	  for (i=0; i<16384; i++) arr1[i]=arr2[i];
	    break;

/* The 3-D variant uses the von Neumann neighborhood, giving two */
/* neioghbors in each dimension surrounding a central cell, for  */
/* a total of 7 neighbors. The array is 32x32x16.		 */

case 3: if (j<16384) break;
	  stzer(); nhzer();
	  for (i0=0; i0<32; i0++)
	  for (i1=0; i1<32; i1++)
	  for (i2=0; i2<16; i2++) {
	    j0=arr1[ix3(i0-1,i1,i2)];
	    j1=arr1[ix3(i0+1,i1,i2)];
	    j2=arr1[ix3(i0,i1-1,i2)];
	    j3=arr1[ix3(i0,i1,i2)];
	    j4=arr1[ix3(i0,i1+1,i2)];
	    j5=arr1[ix3(i0,i1,i2-1)];
	    j6=arr1[ix3(i0,i1,i2+1)];
	    kk=binrule[j0][j1][j2][j3][j4][j5][j6];
	    nhsum[j0][j1][j2][j3][j4][j5][j6]++;
	    arr2[ix3(i0,i1,i2)]=kk;
	    stsum[(int)kk]++;
	    }
	  for (i=0; i<16384; i++) arr1[i]=arr2[i];
	    break;

/* A 7-cell 4-dimensional neighborhood can be fabricated by */
/* taking one neighbor in each dimension, the central cell, */
/* and two fully diagonal neighbors. The neighborhoods are  */
/* 16x8x16x8.						    */

case 4: if (j<16384) break;
	  stzer(); nhzer();
	  for (i0=0; i0<16; i0++)
	  for (i1=0; i1<8; i1++) 
	  for (i2=0; i2<16; i2++)
	  for (i3=0; i3<8; i3++) {
	    j0=arr1[ix4(i0-1,i1-1,i2-1,i3-1)];
	    j1=arr1[ix4(i0+1,i1+1,i2+1,i3+1)];
	    j2=arr1[ix4(i0+1,i1,i2,i3)];
	    j3=arr1[ix4(i0,i1,i2,i3)];
	    j4=arr1[ix4(i0,i1+1,i2,i3)];
	    j5=arr1[ix4(i0,i1,i2+1,i3)];
	    j6=arr1[ix4(i0,i1,i2,i3+1)];
	    kk=binrule[j0][j1][j2][j3][j4][j5][j6];
	    nhsum[j0][j1][j2][j3][j4][j5][j6]++;
	    arr2[ix4(i0,i1,i2,i3)]=kk;
	    stsum[(int)kk]++;
	    }
	  for (i=0; i<16384; i++) arr1[i]=arr2[i];
	    break;

/* A hybrid von Neumann neighborhood can be defined in two   */
/* dimensions by taking second neighbors in one direction,   */
/* first neighbors in the perpendicular direction; including */
/* the central cell this gives seven neighbors. The array    */
/* is 128x128.						     */

case 5: if (j<16384) break;
	  stzer(); nhzer();
	  for (i0=0; i0<128; i0++)
	  for (i1=0; i1<128; i1++) {
	    j0=arr1[ix2(i0,i1-2)];
	    j1=arr1[ix2(i0,i1+2)];
	    j2=arr1[ix2(i0,i1-1)];
	    j3=arr1[ix2(i0,i1)];
	    j4=arr1[ix2(i0,i1+1)];
	    j5=arr1[ix2(i0-1,i1)];
	    j6=arr1[ix2(i0+1,i1)];
	    kk=binrule[j0][j1][j2][j3][j4][j5][j6];
	    nhsum[j0][j1][j2][j3][j4][j5][j6]++;
	    arr2[ix2(i0,i1)]=kk;
	    stsum[(int)kk]++;
	    }
	  for (i=0; i<16384; i++) arr1[i]=arr2[i];
	    break;

/* Another variant 2-D neighborhood consists of two cells to the */
/* left or above, one cell to the right or below, and the center */
/* cell. The array is 128x128.					 */

case 7: if (j<16384) break;
	  for (i0=0; i0<128; i0++) for (i1=0; i1<128; i1++) 
	    arr2[ix2(i0,i1)]=binrule
	      [arr1[ix2(i0,i1+2)]]
	      [arr1[ix2(i0,i1+1)]]
	      [arr1[ix2(i0+2,i1)]]
	      [arr1[ix2(i0,i1)]]
	      [arr1[ix2(i0+1,i1)]]
	      [arr1[ix2(i0-1,i1)]]
	      [arr1[ix2(i0,i1-1)]];
	  for (i=0; i<16384; i++) arr1[i]=arr2[i];
	    break;

default: break;}
}

/* clear neighborhood sums to zeroes */
nhzer() {int i0, i1, i2, i3, i4, i5, i6;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
for (i6=0; i6<KK; i6++)
  nhsum[i0][i1][i2][i3][i4][i5][i6]=0;
}

/* clear state sums to zeroes */
stzer() {int i0; for (i0=0; i0<KK; i0++) stsum[i0]=0;}

/* end lcauk3.c */
