# include "rec.h"
# include <stdio.h>
# include <ctype.h>

# define STRSIZ	2048
static char qbuf[STRSIZ], *qbufp = qbuf;
extern int r_code(), r_stcat();

extern int r_lastchar;

static int bslash(c)
int c;
{
    static char tbl[] = "a\ab\bf\fn\nr\rt\tv\v";
    char *s, *strchr();
    int val, i;
    
    if ((s = strchr(tbl, c)) != (char *) 0)
    	return *++s;
    else {
	val = c;
	i = 3;
	if (c == 'x') {
	    val = 0;
	    while (i-- && isxdigit(c = r_nxtchar())) {
		if (isupper(c))
		    c += '0' + 10 - 'A';
		else if (islower(c))
		    c += '0' + 10 - 'a';
		val = val * 16 + c - '0';
	    }
	    if (i >= 0)
		r_ungetch(c);
	} else if (isdigit(c) && c < '8') {
	    val = c - '0';
	    while (--i && isdigit(c = r_nxtchar()) && c < '8')
		val = val * 8 + c - '0';
	    if (i >= 0)
		r_ungetch(c);
	}
    	return val;
    }
}

static qustr(term)
int term;
{
    int c;

    while ((c = r_nxtchar()) != EOF && c != term) {
	if (c == '\\')
	    c = bslash(r_nxtchar());
	*qbufp++ = c;
	if (qbufp == &qbuf[STRSIZ])
	    r_errterm("quoted string exceeds buffer size");
    }
    return c;
}

r_dquote(func)	/* compilation of double quotes */
Inst func;
{
    Symbol *sym;

    r_code(func);
    if (qustr(r_lastchar) == EOF)
	r_errterm("unbalanced quote");
    if ((sym = r_lookup(qbuf, qbufp - qbuf)) == (Symbol *) 0)
	r_code((Inst) r_install(qbuf, qbufp - qbuf));
    else
	r_code((Inst) sym);
    qbufp = qbuf;
}

r_squote(func)	/* compilation of single quote */
Inst func;
{
    int c, term;
    long val;

    term = r_lastchar;
    r_code(func);
    val = c = r_nxtchar();
    if (c == '\\')
	val = bslash(r_nxtchar());
    if (r_nxtchar() != term)
	r_errterm("Improperly balanced apostrophe");
    r_code((Inst) val);
}
